/*! 
    \file event_handler.h
    \brief Definition of the EventHandler
    
*/

#ifndef _EVENT_HANDLER_H
#define _EVENT_HANDLER_H

#include "base_object.h"
#include "event_def.h"

class EventListener;







//! The one Event Handler from Orxonox
class EventHandler : public BaseObject {

 public:
  static EventHandler* getInstance(void);
  virtual ~EventHandler(void);

  void setState(elState state);

  void subscribeListener(EventListener* el, elState state, int eventType);
  void unsubscribeListener(int eventType, elState state);
  void flush(elState state);

  void tick(float t);
  void process();

 private:
  EventHandler(void);
 

 private:
  static EventHandler* singletonRef;
  EventListener*** listeners;                         //!< a list of registered listeners
  elState state;

};

#endif /* _EVENT_HANDLER_H */
